const { func } = require('joi');
const { DataTypes } = require('sequelize');

module.exports = (sequelize) => {
    const MedicalExamination = sequelize.define('medicalexamination', {
        id: {
            type: DataTypes.INTEGER,
            autoIncrement: true,
            primaryKey: true
        },
        creation: { type: DataTypes.DATE, allowNull: false },
        modified: { type: DataTypes.DATE, allowNull: false },
        modified_by: { type: DataTypes.INTEGER, allowNull: false },
        owner: { type: DataTypes.INTEGER, allowNull: false },

        // main
        name: { type: DataTypes.STRING(150), allowNull: false },
        display_name: { type: DataTypes.STRING(150), allowNull: false },
        description: { type: DataTypes.TEXT, allowNull: true },
        function: { type: DataTypes.TEXT, allowNull: true },

        // fk
    }, {
        tableName: 'medicalexaminations',
        freezeTableName: true
    });

    /**
     * Associates the MedicalExamination model with other models.
     * @param {object} models - The models to associate with.
     * @description
     */
    MedicalExamination.associate = (models) => {
        MedicalExamination.hasMany(models.MedicalExaminationItem, { foreignKey: 'medicalexamination_id', as: 'medicalexaminationitems' });
    };

    return MedicalExamination;
};
